/* $Id: login.c 11 2023-04-25 07:27:30Z nishi $ */
#include <swcli/login.h>

#include <swcli/api.h>
#include <swcli/util.h>

#include <cjson/cJSON.h>

#include <pwd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

extern int argc;
extern char** argv;

void swcli_login(){
	if(argc < 3){
		fprintf(stderr, "%s: URL required\n", argv[0]);
		exit(1);
	}
	struct passwd* pwd = getpwuid(getuid());
	char* path = sstrcat(pwd->pw_dir, "/.swcli-token");
	if(access(path, F_OK) == 0){
		fprintf(stderr, "%s: Run `%s logout` to logout. You have already loginned.\n", argv[0], argv[0]);
		free(path);
		exit(1);
	}
	free(path);
	char* username = malloc(513);
	memset(username, 0, 513);
	printf("Username: ");
	fflush(stdout);
	scanf("%s", username);
	char* password = getpass("Password: ");
	char* tmp = sstrcat(username, ":");
	char* login = sstrcat(tmp, password);
	free(tmp);
	char* url = sstrcat(argv[argc - 1], "/v1/login");
	cJSON* result = swcli_api(url, login);
	free(login);
	if(result == NULL){
		exit(1);
	}else{
		char* token = cJSON_GetObjectItem(result, "token")->valuestring;
		path = sstrcat(pwd->pw_dir, "/.swcli-token");
		FILE* f = fopen(path, "w");
		fwrite(token, strlen(token), 1, f);
		fclose(f);
		free(path);
		path = sstrcat(pwd->pw_dir, "/.swcli-username");
		f = fopen(path, "w");
		fwrite(username, strlen(username), 1, f);
		fclose(f);
		free(path);
		path = sstrcat(pwd->pw_dir, "/.swcli-url");
		f = fopen(path, "w");
		fwrite(argv[argc - 1], strlen(argv[argc - 1]), 1, f);
		fclose(f);
		free(path);
		cJSON_Delete(result);
		printf("%s: Login successful.\n", argv[0]);
	}
}
